/*
 * Created on 17-dic-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.herac.tuxguitar.gui.actions.file;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.TypedEvent;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.printing.PrintDialog;
import org.eclipse.swt.printing.Printer;
import org.eclipse.swt.printing.PrinterData;
import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.gui.actions.Action;
import org.herac.tuxguitar.gui.editors.tab.TGFactoryImpl;
import org.herac.tuxguitar.gui.editors.tab.Tablature;
import org.herac.tuxguitar.gui.editors.tab.layout.PrinterViewLayout;
import org.herac.tuxguitar.gui.helper.SyncThread;
import org.herac.tuxguitar.gui.printer.PrintDocument;
import org.herac.tuxguitar.gui.printer.PrintDocumentData;
import org.herac.tuxguitar.gui.printer.PrintPage;
import org.herac.tuxguitar.song.managers.TGSongManager;

/**
 * @author julian
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PrintAction extends Action{
    public static final String NAME = "action.file.print";
    
    public PrintAction() {
    	super(NAME, AUTO_LOCK | AUTO_UNLOCK | AUTO_UPDATE | KEY_BINDING_AVAILABLE);
    }
    
    protected int execute(TypedEvent e){
		final PrintDocumentData data = PrintDocumentData.openDialog(TuxGuitar.instance().getShell());
		if(data != null){
			PrintDialog dialog = new PrintDialog(TuxGuitar.instance().getShell(), SWT.NULL);
			PrinterData printerData = dialog.open();
    	
			if (printerData != null) {
				print(printerData, data);
			}
		}
    	return 0;
    }
    
	public void print(PrinterData printerData ,final PrintDocumentData data){	
		final Printer printer = new Printer(printerData);
		new Thread(new Runnable() {
			public void run() {
				final TGSongManager manager = new TGSongManager();
				manager.setFactory(new TGFactoryImpl());
				manager.setSong(getSongManager().getSong().clone(manager.getFactory()));		
				
				new SyncThread(new Runnable() {
					public void run() {
						Tablature tablature = new Tablature(getEditor().getTablature());
						tablature.setSongManager(manager);
						
						PrinterViewLayout layout = new PrinterViewLayout(tablature,data, getPrinterScale(printer));
						
						print(printer, layout );				
					}
				}).start();
			}
		}).start();
	}
	
	protected void print(final Printer printer,final PrinterViewLayout layout){
        new Thread(new Runnable() {
			public void run() {
				final Rectangle area = getPrinterArea(printer,0.5);
				
				layout.getTablature().updateTablature();
				layout.getTablature().getCaret().update(getEditor().getTablature().getCaret().getTrack().getNumber());
				new SyncThread(new Runnable() {
					public void run() {
						final PrintDocument document = layout.makeDocument( (area.width - area.x), (area.height - area.y));        
						layout.getTablature().dispose();
						print(printer, document,area);
					}
				}).start();
			}
		}).start();	
	}
	
	protected void print(final Printer printer, final PrintDocument document,final Rectangle area){
		new Thread(new Runnable() {
			public void run() {
				if (printer.startJob("TuxGuitar")) {
		        
					for(int i = 0; i < document.count(); i ++){
						PrintPage page = (PrintPage)document.getPages().get(i);
            	
						if (printer.startPage()) {
							GC gc = new GC(printer);
							Image image = new Image(printer,page.getData());
                
							// Draw the image
							gc.drawImage(image,area.x,area.y);
					    	
							// Clean up
							image.dispose();
							gc.dispose();
							printer.endPage();
						}
					}
				}
				printer.endJob();
				printer.dispose();
			}
		}).start();
	}
	
	protected Rectangle getPrinterArea(Printer printer,double margin) {
		Rectangle clientArea = printer.getClientArea();
		Rectangle trim = printer.computeTrim(0, 0, 0, 0);
		Point dpi = printer.getDPI();

		int x = (int) (margin * dpi.x) - trim.x;
		int y = (int) (margin * dpi.y) - trim.y;
		int width = clientArea.width + trim.width - (int) (margin * dpi.x) - trim.x;
		int height = clientArea.height + trim.height - (int) (margin * dpi.y) - trim.y;

		return new Rectangle(x,y,width,height);
	}    
    
	protected float getPrinterScale(Printer printer) {
		Point dpi = printer.getDPI();
		if( dpi != null ){
			return ( dpi.x / 100.0f );
		}
		return 1.0f;
	}
	
}