/*
 * Created on 17-dic-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.herac.tuxguitar.gui.actions.file;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.TypedEvent;
import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.gui.actions.Action;
import org.herac.tuxguitar.gui.editors.tab.TGFactoryImpl;
import org.herac.tuxguitar.gui.editors.tab.Tablature;
import org.herac.tuxguitar.gui.editors.tab.layout.PrinterViewLayout;
import org.herac.tuxguitar.gui.helper.SyncThread;
import org.herac.tuxguitar.gui.printer.PrintDocument;
import org.herac.tuxguitar.gui.printer.PrintDocumentData;
import org.herac.tuxguitar.gui.printer.PrintPreview;
import org.herac.tuxguitar.gui.util.MessageDialog;
import org.herac.tuxguitar.song.managers.TGSongManager;

/**
 * @author julian
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PrintPreviewAction extends Action{
    public static final String NAME = "action.file.print-preview";
    
    public PrintPreviewAction() {
    	super(NAME, AUTO_LOCK | AUTO_UNLOCK | AUTO_UPDATE | KEY_BINDING_AVAILABLE);
    }    
    
    protected int execute(TypedEvent e){
    	final PrintDocumentData data = PrintDocumentData.openDialog(TuxGuitar.instance().getShell());
		if(data != null){	 
			new SyncThread(new Runnable() {
				public void run() {
					try{
						printPreview(data);
					}catch(Throwable throwable){
						MessageDialog.errorMessage(throwable);
					}
				}
			}).start();
		}
    	return 0;
    }
    
	public void printPreview(final PrintDocumentData data){	
		TuxGuitar.instance().updateCache(false);
		TuxGuitar.instance().loadCursor(SWT.CURSOR_WAIT);
		new Thread(new Runnable() {
			public void run() {
				try{
					final TGSongManager manager = new TGSongManager();
					manager.setFactory(new TGFactoryImpl());
					manager.setSong(getSongManager().getSong().clone(manager.getFactory()));		
				
					printPreview(manager,data);
				}catch(Throwable throwable){
					MessageDialog.errorMessage(throwable);
				}				
			}
		}).start();
	}    
    
	public void printPreview(final TGSongManager manager, final PrintDocumentData data){	
		new SyncThread(new Runnable() {
			public void run() {
				try{
					Tablature tablature = new Tablature(getEditor().getTablature());
					tablature.setSongManager(manager);        
		        
					PrinterViewLayout layout = new PrinterViewLayout(tablature,data, 1f);

					printPreview( layout );
				}catch(Throwable throwable){
					MessageDialog.errorMessage(throwable);
				}
			}
		}).start();  		        
	}

	public void printPreview(final PrinterViewLayout layout){	
		new Thread(new Runnable() {
			public void run() {
				try{	
					layout.getTablature().updateTablature();					
					layout.getTablature().getCaret().update(getEditor().getTablature().getCaret().getTrack().getNumber());
					new SyncThread(new Runnable() {
						public void run() {
							PrintDocument document = layout.makeDocument(850,1050);
							layout.getTablature().dispose();
							PrintPreview preview = new PrintPreview(document);
							preview.showPreview(getEditor().getTablature().getShell()); 
						}
					}).start(); 
				}catch(Throwable throwable){
					MessageDialog.errorMessage(throwable);
				}
			}
		}).start();  		
	}
}
