/*
 * Created on 04-ene-2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.herac.tuxguitar.gui.editors.tab.layout;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.gui.editors.TGPainter;
import org.herac.tuxguitar.gui.editors.tab.TGChordImpl;
import org.herac.tuxguitar.gui.editors.tab.TGLyricImpl;
import org.herac.tuxguitar.gui.editors.tab.TGMeasureImpl;
import org.herac.tuxguitar.gui.editors.tab.TGTrackImpl;
import org.herac.tuxguitar.gui.editors.tab.Tablature;
import org.herac.tuxguitar.gui.printer.PrintDocument;
import org.herac.tuxguitar.gui.printer.PrintDocumentData;
import org.herac.tuxguitar.song.models.TGMeasure;
import org.herac.tuxguitar.song.models.TGTrack;

/**
 * @author julian
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PrinterViewLayout extends ViewLayout{
	
	private static final int DEFAULT_SCORE_LINE_SPACING = 7;
	private static final int DEFAULT_STRING_SPACING = 8;
	private static final int DEFAULT_HORIZONTAL_SPACING = 15;
	private static final int MIN_SCORE_TAB_SPACING =  15;
	private static final int DEFAULT_TRACK_SPACING = 5;
	private static final int DEFAULT_FIRST_TRACK_SPACING = DEFAULT_TRACK_SPACING;
	private static final int DEFAULT_MIN_BUFFER_SEPARATOR = 15;
	private static final int DEFAULT_MIN_TOP_SPACING = 20;
	private static final int CHORD_FRET_INDEX_SPACING = 7;
	private static final int CHORD_STRING_SPACING = 4;
	private static final int CHORD_FRET_SPACING = 5;	
	
	private PrintDocument document;
	private PrintDocumentData documentData;
    private Image image;
    
    public PrinterViewLayout(Tablature tablature,PrintDocumentData data, float scale){
    	super(tablature,( data.getStyle() | DISPLAY_COMPACT ), scale );
        this.documentData = data;
    }

    protected void init( float scale ){
    	this.setFirstMeasureSpacing( getScaledValue(scale , DEFAULT_HORIZONTAL_SPACING ) );
    	this.setMinBufferSeparator( getScaledValue(scale ,  DEFAULT_MIN_BUFFER_SEPARATOR ) );
    	this.setMinTopSpacing( getScaledValue(scale ,  DEFAULT_MIN_TOP_SPACING ) );
    	this.setMinScoreTabSpacing( getScaledValue(scale ,  MIN_SCORE_TAB_SPACING ) );
    	this.setScoreLineSpacing( getScaledValue(scale ,  DEFAULT_SCORE_LINE_SPACING , 4) );
    	this.setScoreSpacing( (( getScoreLineSpacing() * 4) + getMinScoreTabSpacing() ) );
    	this.setFirstTrackSpacing( getScaledValue(scale ,  DEFAULT_FIRST_TRACK_SPACING ) );
    	this.setTrackSpacing( getScaledValue(scale ,  DEFAULT_TRACK_SPACING ) );
    	this.setStringSpacing( getScaledValue(scale ,  DEFAULT_STRING_SPACING  , 4) );
    	this.setChordFretIndexSpacing( getScaledValue(scale ,  CHORD_FRET_INDEX_SPACING ) );
    	this.setChordStringSpacing( getScaledValue(scale ,  CHORD_STRING_SPACING ) );
    	this.setChordFretSpacing( getScaledValue(scale ,  CHORD_FRET_SPACING ) );
    	this.setChordNoteSize(getScaledValue(scale ,  4 ));
    	this.setRepeatEndingSpacing( getScaledValue(scale ,  20 ) );
    	this.setEffectSpacing( getScaledValue(scale ,  8 ) );
    	this.setScale( checkScale() );
    	this.setFontScale( scale );
    	
    	// Initialize Tablature Defaults
		this.getTablature().setViewLayout( this ) ;
		this.getTablature().initDefaults();
    }    

    public int getMode(){
    	return 0;
    }
    
    public PrintDocument makeDocument(int width,int height){
    	return makeDocument(new Point(width,height));
    }

    public PrintDocument makeDocument(Point size){    	
    	//-------init document-------------------------------------------------------
    	this.document = new PrintDocument();
    	this.document.setPageSize(size);
    	//-------draw the image------------------------------------------------------
    	this.image = new Image(getTablature().getDisplay(),new Rectangle(0,0,this.document.getPageSize().x,this.document.getPageSize().y));
    	TGPainter painter = new TGPainter(new GC(this.image));
    	paintHeader(painter);
    	paintSong(painter,null,0,Math.round(80.0f * getFontScale() ));
    	painter.dispose();
    	this.image.dispose();
    	return this.document;
    }
    
    private void makePage(TGPainter painter){
    	String pageNumber = Integer.toString(this.document.count() + 1);
    	
    	painter.setBackground(getTablature().getDisplay().getSystemColor(SWT.COLOR_WHITE));
    	painter.setForeground(getTablature().getDisplay().getSystemColor(SWT.COLOR_BLACK));
    	painter.drawString(pageNumber,getRight(painter,pageNumber),getBottom(painter,pageNumber));
    	
    	this.document.makePage(this.image.getImageData());
    	
    	painter.initPath(TGPainter.PATH_FILL);
    	painter.addRectangle(new Rectangle(0,0,this.document.getPageSize().x,this.document.getPageSize().y));
    	painter.closePath();    	
    }
    
    public void paintHeader(TGPainter painter){
    	String songName = getSongManager().getSong().getName();
    	String songAuthor = getSongManager().getSong().getAuthor();
    	String trackName = "(" + getSongManager().getTrack(this.documentData.getTrackNumber()).getName() + ")";
    	
    	if(songName == null || songName.length() == 0){
    		songName = TuxGuitar.getProperty("print-header.default-song-name");
    	}
    	if(songAuthor == null || songAuthor.length() == 0){
    		songAuthor = TuxGuitar.getProperty("print-header.default-song-author");
    	}
    	Font songNameFont = new Font(getTablature().getDisplay(),"Sans",Math.round(16.0f * getFontScale()), SWT.BOLD | SWT.CENTER);
    	Font trackNameFont = new Font(getTablature().getDisplay(),"Sans",Math.round(8.0f * getFontScale()), SWT.BOLD | SWT.CENTER);
    	Font songAuthorFont = new Font(getTablature().getDisplay(),"Sans",Math.round(8.0f * getFontScale()), SWT.BOLD | SWT.CENTER);
    		
    	painter.setFont(songNameFont);  
    	painter.drawString(songName,getCenter(painter,songName),0);
    	painter.setFont(trackNameFont);
    	painter.drawString(trackName,getCenter(painter,trackName),Math.round(30.0f * getFontScale()));
    	painter.setFont(songAuthorFont);
    	painter.drawString(songAuthor,getRight(painter,songAuthor),Math.round(50.0f * getFontScale()));
    	
    	songNameFont.dispose();
    	trackNameFont.dispose();
    	songAuthorFont.dispose();
    }
    
    private int getCenter(TGPainter painter,String text){
    	int textWidth = painter.getStringExtent(text).x;
    	return ((getMaxWidth() - textWidth) / 2);
    }

    private int getRight(TGPainter painter,String text){
    	int textWidth = painter.getStringExtent(text).x;
    	return ((getMaxWidth() - textWidth));
    }

    private int getBottom(TGPainter painter,String text){
    	int textHeight = painter.getStringExtent(text).y;
    	return ((getMaxHeight() - textHeight));
    }
    
    public void paintSong(TGPainter painter,Rectangle clientArea,int fromX,int fromY) {    	
    	this.setWidth(0);
    	this.setHeight(0);
    	
    	int style = getStyle();
    	int posY = fromY + getFirstTrackSpacing();
    	int height = getFirstTrackSpacing();
    	int lineHeight = 0;    	
    	
    	TGTrackImpl track = (TGTrackImpl)getSongManager().getTrack(this.documentData.getTrackNumber());
    	((TGLyricImpl)track.getLyrics()).start(getSkippedBeats(track));
    	
		TrackSpacing ts = new TrackSpacing(this) ;
		TempLine line = getTempLines(track,( this.documentData.getFromMeasure() - 1 ),ts);
		while(!line.measures.isEmpty()){
    		            
            ts.setSize(TrackSpacing.POSITION_SCORE_MIDDLE_LINES, ((style & DISPLAY_SCORE) != 0?( (getScoreLineSpacing() * 5) ):0));
			if((style & DISPLAY_SCORE) != 0){    			
            	ts.setSize(TrackSpacing.POSITION_SCORE_UP_LINES, Math.abs(line.minY));            	            
            	if(line.maxY + getMinScoreTabSpacing() > getScoreSpacing()){
            		ts.setSize(TrackSpacing.POSITION_SCORE_DOWN_LINES, (line.maxY - (getScoreLineSpacing() * 4)) );
            	}	
			}    	
			if((style & DISPLAY_TABLATURE) != 0){
				ts.setSize(TrackSpacing.POSITION_TABLATURE_TOP_SEPARATOR,((style & DISPLAY_SCORE) != 0 ?getMinScoreTabSpacing():getStringSpacing()));
				ts.setSize(TrackSpacing.POSITION_TABLATURE, ((style & DISPLAY_SCORE) != 0 ?track.getTabHeight() + getStringSpacing() +1:track.getTabHeight() + ((getStringSpacing() / 2) * 5) +1 ) );
			}
			ts.setSize(TrackSpacing.POSITION_LYRIC,10);            
            checkDefaultSpacing(ts);
            
			lineHeight = ts.getSize();    			
    		//Verifico si entra en la pagina actual
    		if((posY + lineHeight + getTrackSpacing()) > getMaxHeight()){
               	makePage(painter);
               	posY = getFirstTrackSpacing();
            }    			
    		//pinto la linea
    		paintLine(track,line,painter,fromX,posY,ts);
                
            posY += lineHeight + getTrackSpacing();    
    		height += lineHeight + getTrackSpacing();           		       
    		
    		ts = new TrackSpacing(this) ;
    		line = getTempLines(track,( line.lastIndex + 1 ),ts);
    	}    	

    	//Creo la ultima pagina
		this.makePage(painter);
       	this.setHeight(height);
    }
    
    
    
    public void paintLine(TGTrackImpl track,TempLine line,TGPainter painter,int fromX, int fromY,TrackSpacing ts) {  
    	int posX = fromX;
        int posY = fromY;
        int width = 0;

        int measureSpacing = 0;
        if(line.fullLine){
        	int diff = ( getMaxWidth() - line.tempWith);
        	if(diff != 0 && line.measures.size() > 0){
        		measureSpacing = diff / line.measures.size();                    
        	}
        }
            
        for(int i = 0;i < line.measures.size();i ++){
          	int index = ((Integer)line.measures.get(i)).intValue();
            TGMeasureImpl currMeasure = (TGMeasureImpl)track.getMeasure(index);
                    
            //asigno la posicion dentro del compas
            currMeasure.setPosX(posX);
            currMeasure.setPosY(posY);              
            currMeasure.setTs(ts);
            
            ((TGLyricImpl)track.getLyrics()).setCurrentMeasure(currMeasure);
            
            currMeasure.setFirstOfLine(i == 0);

            paintMeasure(currMeasure,painter,measureSpacing);
            ((TGLyricImpl)track.getLyrics()).paintCurrentNoteBeats(painter,this,currMeasure,posX, posY);
            
            int measureWidth = ( currMeasure.getWidth(this) + currMeasure.getSpacing() );
            posX += measureWidth;
            width += measureWidth;                                   
        }
        this.setWidth(Math.max(getWidth(),width));
    }                     
    
    public TempLine getTempLines(TGTrack track,int fromIndex,TrackSpacing ts) {          
    	TempLine line = new TempLine();
    	int measureCount = track.countMeasures();
    	for (int measureIdx = fromIndex; measureIdx < measureCount; measureIdx++) {         	
            TGMeasureImpl measure= (TGMeasureImpl) track.getMeasure(measureIdx);                
            if(measure.getNumber() >= this.documentData.getFromMeasure() && measure.getNumber() <= this.documentData.getToMeasure() ){
         
            	//verifico si tengo que bajar de linea
            	if((line.tempWith + measure.getWidth(this)) >=  getMaxWidth() && !line.measures.isEmpty()){
            		line.fullLine = true;
            		return line;
            	}
            	line.tempWith +=  measure.getWidth(this);
            	line.maxY = (measure.getMaxY() > line.maxY)?measure.getMaxY():line.maxY;
            	line.minY = (measure.getMinY() < line.minY)?measure.getMinY():line.minY;
        	
            	line.addMeasure(measureIdx);
            	measure.registerEffects(this,ts);
            }
        }        
       
        return line;
    }    
    
    public int getSkippedBeats(TGTrack track) {
    	int beats = 0;
    	
        for (int i = 0; i < (this.documentData.getFromMeasure() - 1); i++) {         	
            TGMeasureImpl measure = (TGMeasureImpl) track.getMeasure(i);
            beats += measure.getNotEmptyBeats();
        }               
        return beats;
    }    

    public boolean isCaretVisible(){
    	return false;
    }

    public boolean isPlayModeEnabled(){
    	return false;
    }

    public void setTabNoteStyle(TGPainter painter,boolean playMode){
    	painter.setForeground( (playMode ? getResources().getPlayNoteColor() : getResources().getTabNoteColor() ));
    	painter.setBackground( getResources().getBackgroundColor() );
    	painter.setFont(getResources().getPrinterNoteFont());  
    }    
    
    public void setTimeSignatureStyle(TGPainter painter){
    	painter.setFont(getResources().getPrinterTimeSignatureFont());
    	painter.setBackground(getResources().getBackgroundColor());
    	painter.setForeground(TuxGuitar.instance().getDisplay().getSystemColor(SWT.COLOR_BLACK));
    }
    
    public void setGraceStyle(TGPainter painter){
    	painter.setFont(getResources().getPrinterGraceFont());
    	painter.setBackground(getResources().getBackgroundColor());
    }    
    
    public void setLyricStyle(TGPainter painter,boolean playMode){
    	painter.setFont(getResources().getPrinterLyricFont());
    	painter.setBackground(getResources().getBackgroundColor());
    	painter.setForeground( (playMode ? getResources().getPlayNoteColor() : TuxGuitar.instance().getDisplay().getSystemColor(SWT.COLOR_BLACK)) );
    }

    public void setTextStyle(TGPainter painter){
    	painter.setFont(getResources().getPrinterTextFont());
    	painter.setBackground(getResources().getBackgroundColor());
    	painter.setForeground(TuxGuitar.instance().getDisplay().getSystemColor(SWT.COLOR_BLACK));
    }    
    
    public void setChordStyle(TGPainter painter,TGChordImpl chord){
    	painter.setFont(getResources().getPrinterChordFont());
    	painter.setBackground(getResources().getBackgroundColor());
    	painter.setForeground(TuxGuitar.instance().getDisplay().getSystemColor(SWT.COLOR_BLACK));
    	chord.setStyle(getStyle());
    	chord.setBackgroundColor(getResources().getBackgroundColor());
    	chord.setColor(getResources().getLineColor());
    	chord.setNoteColor(getResources().getTabNoteColor());
    	chord.setTonicColor(getResources().getTabNoteColor());
    	chord.setFretSpacing(getChordFretSpacing());
    	chord.setStringSpacing(getChordStringSpacing());
    	chord.setNoteSize(getChordNoteSize());
    	chord.setFirstFretSpacing(0);
    	chord.setFirstFretFont(null);
    }
    
    public int getMaxWidth(){
        return (this.document.getPageSize().x - 10);
    }
    
    public int getMaxHeight(){
        return (this.document.getPageSize().y - 10);
    }    

    public boolean isFirstMeasure(TGMeasure measure){
    	return (measure.getNumber() == this.documentData.getFromMeasure());
    }

    public boolean isLastMeasure(TGMeasure measure){
    	return (measure.getNumber() == this.documentData.getToMeasure());
    }

    private int getScaledValue(float scale, int value){
    	return getScaledValue(scale, value,1);
    }
    private int getScaledValue(float scale, int value, int minimum){
    	float scaledValue = ( value * scale );
    	return Math.max( Math.round( scaledValue ) , minimum );
    }

    private class TempLine{    	
    	protected int tempWith;    	
    	protected int lastIndex;
    	protected boolean fullLine;    	    
    	protected int maxY = 0;
    	protected int minY = 50;
    	protected List measures;
    	
    	public TempLine(){
    		this.measures = new ArrayList(); 
    	}
    	
    	protected void addMeasure(int index){
    		this.measures.add(new Integer(index));
    		this.lastIndex = index;
    	}
    }
}
