package org.herac.tuxguitar.player.impl.sequencer;

public class MidiTickPlayer {	
	private int tempo;		
	private long tick;	
	private long time;
	private long lastTime;	
	private long tickLength;
	
	public MidiTickPlayer(){
		super();
	}
	
	public void process() {									
		this.lastTime = this.time;
		this.time = System.currentTimeMillis(); 
		this.tick +=  (long)((double)getTempo() * (double)(this.time - this.lastTime) / 60.00);
	}

	public void clearTick(){
		this.tickLength = 0;
	}

	public int getTempo() {
		return this.tempo;
	}

	public void setTempo(int tempo) {
		this.tempo = tempo;
	}

	public long getTick() {
		return this.tick;
	}

	public void setTick(long tick) {
		this.tick = tick;
		this.time = System.currentTimeMillis();
	}

	public long getTickLength() {
		return this.tickLength;
	}				
	
	public void notifyTick(long tick){
		this.tickLength = Math.max(this.tickLength,tick);
	}
}
